/**
 * 
 */
package cz.muni.fi.pb162.radio;

import cz.muni.fi.pb162.music.Song;
import cz.muni.fi.pb162.radio.parts.CDPlayer;
import cz.muni.fi.pb162.radio.parts.Displayable;
import cz.muni.fi.pb162.radio.parts.GivingSound;
import cz.muni.fi.pb162.radio.parts.Switchable;

import java.util.Arrays;

/**
 * @author xpecho
 * 
 */
public class CarRadio extends UniversalRadio implements CDPlayer {

	private Song[] cd;

	private int actualSongIndex = -1;

	/**
	 * @param radioSwitch
	 * @param speaker
	 * @param display
	 */
	public CarRadio(Switchable radioSwitch, GivingSound speaker,
			Displayable display) {
		super(radioSwitch, speaker, display);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see cz.muni.fi.pb162.radio.parts.CDPlayer#ejectCD()
	 */
	public Song[] ejectCD() {
		Song[] temp = cd;
		this.cd = null;
		return temp;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see cz.muni.fi.pb162.radio.parts.CDPlayer#next()
	 */
	public void next() {
		if(actualSongIndex < cd.length -1){
			actualSongIndex++;
		}else {
			actualSongIndex = 0;
		}

	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see cz.muni.fi.pb162.radio.parts.CDPlayer#play()
	 */
	public void play() {
		actualSongIndex = 0;

	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see cz.muni.fi.pb162.radio.parts.CDPlayer#previous()
	 */
	public void previous() {
		if (actualSongIndex > 0) {
			actualSongIndex--;
		}else {
			actualSongIndex = cd.length -1;
		}
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * cz.muni.fi.pb162.radio.parts.CDPlayer#putCD(cz.muni.fi.pb162.music.Song
	 * [])
	 */
    public void putCD(Song[] cd) {
		this.cd = cd;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see cz.muni.fi.pb162.radio.parts.CDPlayer#stop()
	 */
	public void stop() {
		actualSongIndex = -1;
	}

	public Song actualSong() {
		return actualSongIndex > -1? cd[actualSongIndex]: null;
	}

	/* (non-Javadoc)
	 * @see cz.muni.fi.pb162.radio.UniversalRadio#increaseVolume()
	 */
	public void increaseVolume() {
		// TODO Auto-generated method stub
		GivingSound speaker = getSpeaker();
		speaker.setVolume(speaker.getVolume() + 2);
	}

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (!(o instanceof CarRadio)) return false;

        CarRadio carRadio = (CarRadio) o;

        if (actualSongIndex != carRadio.actualSongIndex) return false;
        if (!Arrays.equals(cd, carRadio.cd)) return false;

        return true;
    }

    @Override
    public int hashCode() {
        int result = cd != null ? Arrays.hashCode(cd) : 0;
        result = 31 * result + actualSongIndex;
        return result;
    }
}

